;-----------------------------------------------------------------------
;                          blink_atm8.asm
;
;    Blinky mit ATMega8 und AVRA-Assembler
;
;    24.10.2016 R. Seelig
;
;-----------------------------------------------------------------------


;-----------------------------------------------------------------------
;- Definitionen
;-----------------------------------------------------------------------

.include "m8def.inc"
.def temp     = r16        ; temp ist symbolischer Name fuer Register 16

.equ dtime    = 25
.equ led_0    = (1 << pb1) ; ergibt 0x01 = 0000.0010b => 1. Bit ist 1

;------------------------------------------------------------------------------
;-      Programm Start nach Reset
;-
;-      der Stackpointer wird initialisiert
;-      Register werden gesetzt
;------------------------------------------------------------------------------

reset:                     ; hier startet der Code nach einem Reset

; -------------------------------------------------------
;          Stackpointer initialisieren
; -------------------------------------------------------

  ldi r16, high(RAMEND)
  out SPH,r16
  ldi r16, low(RAMEND)
  out SPL, r16
  ser temp                 ; ser= set register alle Bits eines Registers zu 1
  out DDRB, temp           ; setzt alle PINs von PORTB als Ausgang
  ldi temp, LED_0

;------------------------------------------------------------------------------
;                                M A I N
;------------------------------------------------------------------------------

main:
  ldi r20, led_0
  in r19, PORTB         ; read
  eor r19, r20          ; modify (r19= r19 xor r20 => LED-Bit wird invertiert)
  out PORTB, r19        ; write back

  ldi r19, dtime        ; r19 bestimmt Verzoegerungszeit
  rcall _delay
rjmp MAIN

;-------------------------------------------------------------------------------
;                                _DELAY
; Uebergabe:
;             R19 => Verzoegerungszeit
;-------------------------------------------------------------------------------

_delay:
  ldi r18, 0

_delay_loop0:
  ldi r17, 0

_delay_loop1:
  dec r17
  brne _delay_loop1
  dec r18
  brne _delay_loop0
  dec r19
  brne _delay
  ret
