/* ------------------ blinky.c -------------------

     eine blinkende Leuchtdiode ist das "Hallo
     Welt" Programm in der Microcontrollerwelt

     24.10.2016     R. Seelig

   ----------------------------------------------- */


#include <avr/io.h>               // grundsaetzlich
#include <util/delay.h>


#define led_port      PORTB           // Port an den die LED angeschlossen ist
#define led_ddr       DDRB            // zustaendiges Richtungsregister (In oder Out Direction)
#define led           PB1             // Anschluss der LED am Microcontroller

#define led_init()    led_ddr|= ((1<<led))
#define led_set()     led_port|=((1<<led))
#define led_clr()     led_port&=(~(1<<led))

int main(void)
{
  led_init();

  while (1)                       // fuer immer blinken
  {
    led_set();
    _delay_ms(100);
    led_clr();
    _delay_ms(100);
  }
}
